from analysis.fixed_point import fixed_point
from analysis.available_expressions import AvailableExpressions
from lang.ast.ast import Assignment, BinOp, BinaryExpression, IntegerConstant, Variable
from lang.to_cfg import stringToCFG
from lang.utils import getEntryValue, getExitValue, getExpressionsInCFG, getNodeByLabel, getValueByLabel
from lang.cfg import InnerNode


def test_available_expressions_sequential1():
    s = """
    l1: x = 0 + 1; 
    """
    cfg = stringToCFG(s)
    In, Out = fixed_point(cfg, AvailableExpressions(cfg))
    expr = BinaryExpression(IntegerConstant(0), BinOp.Plus, IntegerConstant(1))
    assert(getEntryValue(Out) == set())
    assert(getExitValue(In) == {expr})
    assert(getValueByLabel("l1", In) == set())
    assert(getValueByLabel("l1", Out) == {expr})


def test_available_expressions_sequential3():
    s = """
    l1: x = a + b;
    l2: y = a + b; 
    """
    cfg = stringToCFG(s)
    In, Out = fixed_point(cfg, AvailableExpressions(cfg))
    assert(BinaryExpression(Variable("a"), BinOp.Plus,
           Variable("b")) in getValueByLabel("l2", In))

