from analysis.fixed_point import fixed_point
from analysis.precise_sign_analysis import PreciseSignAnalysis, Lattice
from lang import stringToCFG
from lang.utils import getValueByLabel
from lang.cfg import Variable


def test_sign_analysis_part_2_1():
    s = r"""
        x = 0;
        if (true) {
          y = x + 1;
        } else {
          y = x;
        }
    l1: z = y; 
    """
    cfg = stringToCFG(s)
    In, Out = fixed_point(cfg, PreciseSignAnalysis(cfg))
    assert ({(Variable("x"), Lattice.Zero), (Variable("y"), Lattice.Positive),
             (Variable("y"), Lattice.Zero)} == getValueByLabel("l1", In))


def test_sign_analysis_part_2_2():
    s = r"""
        x = 0;
        if (true) {
          y = (-1) + x;
        } else {
          y = x;
        }
    l1: z = y; 
    """
    cfg = stringToCFG(s)
    In, Out = fixed_point(cfg, PreciseSignAnalysis(cfg))
    assert ({(Variable("x"), Lattice.Zero), (Variable("y"), Lattice.Negative),
             (Variable("y"), Lattice.Zero)} == getValueByLabel("l1", In))